<template>
<div class="field-group flex">
  <div class="flex-1 flex flex-wrap">
    <Select
      class="mr-2 flex-1" 
      v-model="fieldAttribute.selected"
      :options="fieldAttribute.options"
      optionLabel="label"
      :placeholder="fieldAttribute.placeholder"
      @change="onChangeAttribute"
      >
    </Select>
    <Select
      class=""
      v-model="fieldOperator.selected"
      :options="fieldOperator.options"
      optionLabel="label"
      :placeholder="fieldOperator.placeholder"
      @change="onChangeOperator"
    >
    </Select>
    <div class="flex w-full">
      <SearchInput
        class="flex-1"
        v-if="fieldAttribute.selected && fieldAttribute.selected.value !== 'monasteryStatus'"
        :field="fieldAttribute.selected.value"
        placeholder="Wert"
        :floating-label="false"
        @search="onChangeValues($event)"
      ></SearchInput>
    </div>
  </div>
  <div class="flex items-center justify-center ml-2">
    <Button
        rounded
        size="small"
        icon="pi pi-times"
        outlined
        @click="remove"
        aria-label="Remove"
    ></Button>
  </div>
</div>
</template>

<script>
import Select from 'primevue/select';
import SearchInput from '@/components/SearchInput.vue';

export default {
  name: 'SearchGroup',
  components: {
    SearchInput,
    Select,
  },
  data () {
    return {
      fieldAttribute: {
        name: 'field',
        label: 'Eigenschaft',
        placeholder: 'Eigenschaft',
        selected: {
          value: 'state',
          label: 'Bundesland/Land',
        },
        options: [{
          value: 'state',
          label: 'Bundesland/Land',
        },
        // {
        //   value: 'monasteryStatus',
        //   label: 'Klosterstatus',
        // },
        {
          value: 'personName',
          label: 'Personenname',
        },
        ],
      },
      fieldOperator: {
        name: 'operator',
        label: 'Operator',
        placeholder: 'Operator',
        selected: {
          value: 'eq',
          label: '=',
        },
        options: [
          {
            value: 'eq',
            label: '=',
          },
          // {
          //   value: 'neq',
          //   label: '≠',
          // },
          // {
          //   value: 'like',
          //   label: ' ≈',
          // },
        ],
      },
      values: [],
      dropdownValue: '',
    };
  },
  props: ['search-field', 'operator', 'search-value'],
  // computed: {
  //   monasteryStatuses () {
  //     return this.$store.state.monasteryStatuses;
  //   },
  // },
  methods: {
    onChangeAttribute () {
      this.onChangeValues([]);
    },
    onChangeOperator () {
      this.onChangeValues([]);
    },
    onChangeValues (values) {
      this.values = values;
      this.emitChange();
      this.$emit('search');
    },
    emitChange () {
      this.$emit('change', {
        field: this.fieldAttribute.selected.value,
        operator: this.fieldOperator.selected.value,
        value: this.values,
      });
    },
    remove () {
      this.onChangeValues([]);
      this.$emit('remove');
    },
  },
};
</script>

<style lang="scss" scoped>
</style>
